;=================================
; World 2 Boss - Tutanreznor
; For Morton's Empire
;=================================

;   Note: Most timers are hardcoded and changing them may cause stuff to break - don't touch them if
;   you don't know how to fix/don't feel like scrolling more than 1000 lines of code.
;   They are poorly defined and scattered around, so you will have to fiddle around with the code.

;=================================
; Some defines
;=================================

       ; Defines I have just to not being scrolling like a fucking idiot should the need to change values arise

       !Hitpoints    = $04
       !BigBlockNum  = $01
       !FreeRAM      = $18B4|!Base2;   1 byte
       !StartBig     = 1           ;   if set, Mario will become big before starting the fight

       ;Other

       !RAM_FrameCounterB   = $14
       !RAM_SpriteNum       = !9E
       !RAM_SpriteSpeedY    = !AA
       !RAM_SpriteSpeedX    = !B6
       !RAM_SpriteState     = !C2
       !RAM_SpriteYLo       = !D8
       !RAM_SpriteXLo       = !E4
       !RAM_SpriteStatus    = !14C8
       !RAM_SpriteYHi       = !14D4
       !RAM_SpriteXHi       = !14E0
       !RAM_MiscTracking    = !1504
       !RAM_AttackCounter   = !1510
       !RAM_SpriteHealth    = !1528
       !RAM_AttackBp        = !1534
       !RAM_DecrTblA        = !1540
       !RAM_NoInter         = !1570
       !RAM_SpriteDir       = !157C
       !RAM_ObjStatus       = !1588
       !RAM_SpriteIndex     = $15E9|!Base2
       !RAM_OAMIndex        = !15EA
       !RAM_PoseControl     = !1602
       !RAM_VulnTimer       = !160E
       !RAM_DecrTblB        = !163E
       !RAM_AttackSeed      = !1FD6

       !RAM_Port1           = $1DF9|!Base2
       !RAM_Port4           = $1DFC|!Base2
       
       ; Calls to 1602:
       ; 00 - Walk Animation
       ; 01 - Stand Still
       ; 02 - Open Mouth
       ; 03 - Facing front
       ; 04 - Less open mouth
       ; 80 - Don't display Reznor

;=================================
; INIT and MAIN Wrappers
;=================================

assert read1($02A519) == $5C,      "Please install the Reznor fireball fix patch before inserting this sprite."

print "INIT ",pc
       LDA #!Hitpoints             ;\  health points
       STA !RAM_SpriteHealth,x     ;/
       LDA #$03                    ;\  start facing front
       STA !RAM_PoseControl,x      ;/
       STZ !RAM_AttackSeed,x       ;   allow for any attack at first
       LDA #$46                    ;\  initial timer
       STA !RAM_DecrTblA,x         ;/
       if read1($01ACF9) == $5A
              LDA #$67             ;\
              STA $148B|!Base2     ; | init the vanilla rng with these two seeds
              LDA #$E5             ; |
              STA $148C|!Base2     ;/
       endif
       if !StartBig == 1
              LDA $19              ;\
              BNE +                ; | start big
              INC $19              ;/
       +      
       endif
       RTL

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR TRMain
       LDA !RAM_FrameCounterB
       AND #$03
       BNE +
       LDA !RAM_VulnTimer,x
       BEQ +
       DEC !RAM_VulnTimer,x
+      PLB
       RTL

;========================
; Main routine
;========================

Death:
       LDA #$80
       STA !FreeRAM
       LDA #$02
       STA !RAM_PoseControl,x
       LDA !RAM_DecrTblA,x
       BNE +
       JMP .EndLevel
+      CMP #$40
       BCC .FallIntoLava
       LDY !RAM_OAMIndex,x
       LDA !RAM_FrameCounterB
       LSR #2
       AND #$03
       TAX
       LDA $0303|!Base2,y
       AND #$60
       ORA FlashTable,x
       AND #$6F
       STA $0303|!Base2,y
       STA $0307|!Base2,y
       LDA $030B|!Base2,y
       AND #$60
       ORA FlashTable,x
       AND #$6F
       STA $030B|!Base2,y
       STA $030F|!Base2,y
       LDX !RAM_SpriteIndex
       RTS
.FallIntoLava
       CMP #$29
       BCC .Update
       CMP #$3D
       BNE +
       LDA #$D0
       STA !RAM_SpriteSpeedY,x
+      JSL $01802A
       LDA #$23
       STA !RAM_Port1
       BRA MainReturn
.Update
       CMP #$1C
       BCS +
       LDA #$30
       STA !RAM_SpriteSpeedY,x
       LDA !RAM_DecrTblA,x
       CMP #$0C
       BNE +
       LDA #$20
       STA !RAM_Port4
+      JSL $01801A
       LDA !RAM_DecrTblA,x
       CMP #$09
       BCS MainReturn
       LDY !RAM_OAMIndex,x
       LDA $0303|!Base2,y
       AND #$0F
       STA $0303|!Base2,y
       STA $0307|!Base2,y
       LDA $030B|!Base2,y
       AND #$0F
       STA $030B|!Base2,y
       STA $030F|!Base2,y
       RTS
.EndLevel
       LDY !RAM_OAMIndex,x
       LDA $0303|!Base2,y
       AND #$0F
       STA $0303|!Base2,y
       STA $0307|!Base2,y
       LDA $030B|!Base2,y
       AND #$0F
       STA $030B|!Base2,y
       STA $030F|!Base2,y
       LDA #$FE
       STA $1DFB|!Base2
       LDA #$FF                    ;\  activate "end level" flag
       STA $1493|!Base2            ;/
       STZ $141C|!Base2            ;   normal path
       LDA #$0B
       STA $71
MainReturn:
       RTS

TRMain:
       JSR Graphics                ;   draw
       LDA !RAM_SpriteStatus,x     ;\
       EOR #$08                    ; | return if sprites locked or status not normal
       ORA $9D                     ; |
       BNE MainReturn              ;/

       LDA !RAM_SpriteHealth,x
       BNE +
       JMP Death

+      LDA !RAM_ObjStatus,x
       AND #$04
       BEQ .DontResetX
       LDA !FreeRAM
       BEQ .DontResetX
       STZ !RAM_SpriteSpeedX,x
.DontResetX
       JSL $01802A                 ;   update speed

       LDA !RAM_SpriteState,x      ;\  run intro code if not time to attck yet
       BNE +                       ;/
       JMP HandleIntro
+      BIT !RAM_SpriteState,x
       BMI .GoBack
       BVS .Hurt
       JMP Normal
.Hurt
       JMP Hurt

.GoBack
       LDA !RAM_DecrTblA,x
       BNE MainReturn
       LDA !RAM_AttackBp,x
       ORA #$01
       STA !RAM_AttackBp,x

       BIT !RAM_AttackBp,x
       BMI RespawnA

;== Disappear ==;

DespawnA:
       LDA !RAM_AttackBp,x
       AND #$04
       BNE SkipThisA

       %SpinjumpStars()

       LDA #$04
       STA !RAM_AttackBp,x
       LDA #$1F
       STA !RAM_DecrTblB,x
       LDA #$80
       STA !RAM_PoseControl,x
       RTS

SkipThisA:
       LDA !RAM_DecrTblB,x
       BEQ EndA
       %GetDrawInfo()
       REP #$20
       LDA $00
       SEC
       SBC #$0404
       STA $0300,y
       SEP #$20
       LDA !RAM_DecrTblB,x
       LSR #3
       AND #$03
       TAX
       LDA.l $019A4E,x
       STA $0302|!Base2,y
       LDX !RAM_SpriteIndex
       LDA #$30
       STA $0303|!Base2,y
       RTS

EndA:
       LDY !RAM_SpriteHealth,x
       DEY
       LDA ReappearTimes,y
       STA !RAM_DecrTblA,x
       LDA #$80
       STA !RAM_AttackBp,x
       RTS

;== Reappear ==;

RespawnA:
       LDA !RAM_AttackBp,x
       AND #$04
       BNE SkipThisB

       LDA #$20
       STA !RAM_SpriteXLo,x
       STZ !RAM_SpriteYLo,x
       LDA #$01
       STA !RAM_SpriteYHi,x
       STZ !RAM_SpriteDir,x

       %SpinjumpStars()

       LDA #$84
       STA !RAM_AttackBp,x
       LDA #$1F
       STA !RAM_DecrTblB,x
       LDA #$01
       STA !RAM_PoseControl,x
       RTS

SkipThisB:
       LDA !RAM_DecrTblB,x
       BEQ EndB
       %GetDrawInfo()
       REP #$20
       LDA $00
       SEC
       SBC #$0404
       STA $0200|!Base2
       SEP #$20
       LDA !RAM_DecrTblB,x
       LSR #3
       AND #$03
       TAX
       LDA.l $019A4E,x
       STA $0202|!Base2
       LDX !RAM_SpriteIndex
       LDA #$30
       STA $0203|!Base2
       LDA #$02
       STA $0420|!Base2
       RTS

EndB:
       LDA #$F0
       STA $0201|!Base2
       LDA #$18
       STA !RAM_DecrTblA,x
       LDA #$01
       STA !RAM_SpriteState,x
       STZ !RAM_AttackBp,x
       STZ !RAM_AttackSeed,x
       RTS

;== Normal Status ==;

Normal:
       LDA !RAM_VulnTimer,x
       BEQ +
       DEC
       BNE .Interact
       STZ !FreeRAM
       LDA #$80
       STA !RAM_SpriteState,x
.Return
       RTS

; Movement related code and misc. JSRs
+      JSR AttackAI
       ;LDA !RAM_NoInter,x
       ;BNE .Return
.Interact
       LDA !RAM_PoseControl,x
       BMI .Return
       JMP Interaction

;== Intro Code ==;

HandleIntro:
       STZ $76                     ;\
       STZ $7B                     ; | block move
       STZ $7D                     ;/
       LDA #$B5                    ;\  player pose
       STA $13E0|!Base2            ;/

       LDA !RAM_ObjStatus,x        ;\
       AND #$04                    ; | return if on air
       BEQ ReturnIntro             ;/

       LDA #$01                    ;\  change pose
       STA !RAM_PoseControl,x      ;/

       LDA !RAM_DecrTblA,x         ;\  return if done
       BEQ RetIncrease             ;/
       CMP #$0F                    ;\
       BCC EverHeardOfMacroLabels  ; | :thinking_face:
       CMP #$20                    ; |
       BNE ReturnIntro             ;/

       LDX #$01                    ;   Smoke Loop
-      PHX                         ;   preserve x
       LDX !RAM_SpriteIndex        ;   temporarily restore index
       STZ $00                     ;\
       STZ $01                     ; |
       LDA #$1B                    ; | i cant wait for the daiyousei remoderations
       STA $02                     ; |
       LDA #$01                    ;/
       %SpawnSmoke()               ;   draw smoke in the position
       PLX                         ;   restore x
       LDA $17C8|!Base2,y          ;\
       CLC                         ; | smoke x pos
       ADC SmokePositions,x        ; |
       STA $17C8|!Base2,y          ;/
       LDA $17C4|!Base2,y          ;\
       CLC                         ; | smoke y pos
       ADC #$07                    ; |
       STA $17C4|!Base2,y          ;/

       DEX                         ;\  branch if not time to return yet
       BPL -                       ;/
       LDX !RAM_SpriteIndex        ;   restore index
       RTS

EverHeardOfMacroLabels:
       LDA #$25                    ;\  Rawr :3
       LDA #$25                    ;\  Rawr :3
       STA !RAM_Port1              ;/
       LDA #$02                    ;\  pose: open mouth
       STA !RAM_PoseControl,x      ;/
       RTS

RetIncrease:
       INC !RAM_SpriteState,x      ;   end intro
       LDA #$01
       STA !RAM_PoseControl,x
       LDA #$50                    ;\  some timer idk
       STA !RAM_DecrTblA,x         ;/

ReturnIntro:
       RTS

SmokePositions:
       db $EC,$0C

;== Being hurt code ==;

Hurt:
       LDA !RAM_DecrTblA,x
       BEQ .End
       LDA #$03
       STA !RAM_PoseControl,x
       LDA !RAM_SpriteDir,x
       ASL #2
       STA $03
       LDY !RAM_OAMIndex,x
       LDA !RAM_FrameCounterB
       LSR #2
       AND #$03
       ORA $03
       TAX
       LDA FlashTable,x
       STA $0303|!Base2,y
       STA $0307|!Base2,y
       EOR Flip,x
       STA $030B|!Base2,y
       STA $030F|!Base2,y
       LDX !RAM_SpriteIndex
       RTS
.End
       LDA #$80
       STA !RAM_SpriteState,x
       STZ !FreeRAM
       STZ !RAM_AttackCounter,x
       RTS

FlashTable:
       db $33,$37,$39,$3B
       db $73,$77,$79,$7B
Flip:
       db $40,$40,$40,$40
       db $40,$40,$40,$40

;==================
; Attack Handler
;==================

AttackAI:
       LDA !RAM_AttackSeed,x
       LDY !RAM_AttackBp,x         ;\ not determine next attack if it's bypassed
       BNE LiterallyDie            ;/
-      LDY !RAM_SpriteHealth,x     ;\
       LDA AttackAmount,y          ; | get possible attacks to make       
       %RangedRNG()                ; | jump to ranged RNG
       CMP !RAM_AttackSeed,x       ;  \ determine if attack was already made
       BEQ -                       ;__/
       CMP #$00
       BNE .dont
       LDY !RAM_AttackCounter,x
       CPY #$02
       BCC -
       BRA .clean

.dont
       INC !RAM_AttackCounter,x
       LDY !RAM_AttackCounter,x
       CPY #$04
       BCC LiterallyDie
       STZ !RAM_AttackSeed,x
       LDA #$00
.clean
       STZ !RAM_AttackCounter,x

LiterallyDie:
       STA !RAM_AttackSeed,x       ;   save attack
       ASL                         ;\
       TAY                         ; |
       LDA .Attacks,y              ; | index to pointer
       STA $00                     ; |
       LDA .Attacks+1,y            ; |
       STA $01                     ;/
       JMP (!Base1)                ;   pointer jump

.Attacks
       dw ChargeMario
       dw FireBreath
       dw BowserFire
       dw ShakeAndRocks
       dw LudwigFire

AttackAmount:
       db $00,$04,$03,$02,$02

;========================
; Fireball
;========================

FireBreath:
       INC !RAM_AttackBp,x         ;   avoid attack re-seeding
       LDA !RAM_DecrTblA,x         ;\
       CMP #$01                    ; |
       BEQ .Spit                   ; | determine action:
       CMP #$06                    ; | timer is 01, spit fire, 02 to 05, show open mouth, 06 or more, return
       BCS .Return                 ;/

       LDA #$04                    ;\  less open mouth
       STA !RAM_PoseControl,x      ;/
       RTS

.Spit
       LDA #$02                    ;\  more open mouth
       STA !RAM_PoseControl,x      ;/
       
       LDA !RAM_SpriteXHi,x        ;\
       XBA                         ; |
       LDA !RAM_SpriteXLo,x        ; |
       REP #$20                    ; | $00 - Sprite's X position - Mario's X position
       SEC                         ; |
       SBC $94                     ; |
       STA $00                     ; |
       SEP #$20                    ;/

       LDA !RAM_SpriteYHi,x        ;\
       XBA                         ; |
       LDA !RAM_SpriteYLo,x        ; |
       REP #$20                    ; | $02 - Sprite's Y position - (Mario's Y position - 8)
       SEC                         ; |
       SBC #$0008                  ; |
       SBC $96                     ; |
       STA $02                     ; |
       SEP #$20                    ;/

       LDA #$20                    ;   projectile speed = 20
       %Aiming()                   ;   aim for Mario

       LDA $02                     ;\
       STA $03                     ; |
       LDA $00                     ; | i hope a truck falls over the one who wrote these shared routines
       STA $02                     ; |
       STZ $00                     ; |
       STZ $01                     ;/
       LDA #$02                    ;\  spawn reznor's fireball
       %SpawnExtended()            ; | unless there's no index available
       BCS FireBreath_Return       ;/
       LDA #$06                    ;\  sfx
       STA !RAM_Port4              ;/
       LDA #$01                    ;\  make it a reznore fireball
       STA $1765|!Base2,y          ;/

       LDA #$25                    ;\  time for next fireball
       STA !RAM_DecrTblA,x         ;/

       LDA !RAM_MiscTracking,x     ;\
       INC                         ; |
       STA !RAM_MiscTracking,x     ; | return if we haven't spawned three fireballs
       CMP #$03                    ; |
       BCC FireBreath_Return       ;/
       LDY !RAM_SpriteHealth,x     ;\
       DEY                         ; | timer
       LDA AttckTimer,y            ; |
       STA !RAM_DecrTblA,x         ;/
       STZ !RAM_AttackBp,x         ;   allow for another attacks
       STZ !RAM_MiscTracking,x     ;   allow to be re-used
       LDA #$01
       STA !RAM_PoseControl,x      ;   reset pose
FireBreath_Return:
       RTS

;========================
; Spawn Ludwig Fireballs
;========================

LudwigFire:
       INC !RAM_AttackBp,x         ;   avoid attack re-seeding
       LDA !RAM_DecrTblA,x         ;\
       CMP #$01                    ; |
       BEQ .Spit                   ; | determine action:
       CMP #$06                    ; | timer is 01, spit fire, 02 to 05, show open mouth, 06 or more, return
       BCS .Return                 ;/

       LDA #$04                    ;\  less open mouth
       STA !RAM_PoseControl,x      ;/
       RTS

.Spit
       LDA #$02                    ;\  more open mouth
       STA !RAM_PoseControl,x      ;/
       
       LDA !RAM_SpriteXHi,x        ;\
       XBA                         ; |
       LDA !RAM_SpriteXLo,x        ; |
       REP #$20                    ; | $00 - Sprite's X position - Mario's X position
       SEC                         ; |
       SBC $94                     ; |
       STA $00                     ; |
       SEP #$20                    ;/

       LDA !RAM_SpriteYHi,x        ;\
       XBA                         ; |
       LDA !RAM_SpriteYLo,x        ; |
       REP #$20                    ; | $02 - Sprite's Y position - (Mario's Y position - 8)
       SEC                         ; |
       SBC #$0008                  ; |
       SBC $96                     ; |
       STA $02                     ; |
       SEP #$20                    ;/

       LDA #$25                    ;   projectile speed = 20
       %Aiming()                   ;   aim for Mario

       LDA $02                     ;\
       STA $03                     ; |
       LDA $00                     ; | i hope a truck falls over the one who wrote these shared routines
       STA $02                     ; |
       STZ $00                     ; |
       STZ $01                     ;/
       LDA #$34                    ;\
       CLC                         ; | spawn ludwig's fireball
       %SpawnSprite()              ; | unless there's no index available
       BCS LudwigFire_Return       ;/
       TYX

       LDA #$27                    ;\  sfx
       STA !RAM_Port4              ;/

       LDX !RAM_SpriteIndex

       LDA #$12                    ;\  time for next fireball
       STA !RAM_DecrTblA,x         ;/

       LDA !RAM_MiscTracking,x     ;\
       INC                         ; |
       STA !RAM_MiscTracking,x     ; | return if we haven't spawned four fireballs
       CMP #$04                    ; |
       BCC LudwigFire_Return       ;/
       LDY !RAM_SpriteHealth,x     ;\
       DEY                         ; | timer
       LDA AttckTimer,y            ; |
       STA !RAM_DecrTblA,x         ;/
       STZ !RAM_AttackBp,x         ;   allow for another attacks
       STZ !RAM_MiscTracking,x     ;   allow to be re-used
       LDA #$01
       STA !RAM_PoseControl,x      ;   reset pose
LudwigFire_Return:
       RTS

;========================
; Spawn Bowser Fireballs
;========================

BowserFire:
       LDA !RAM_DecrTblA,x         ;\
       CMP #$01                    ; | determine action:
       BEQ .Fire                   ; | timer is 01, spawn fire, 02 to 04, show open mouth, 05 or more, return
       LDY !RAM_AttackBp,x         ;  \ don't roar twice
       BMI .Return                 ;  /
       INC !RAM_AttackBp,x         ; | avoid attack re-seeding
       CMP #$05                    ; |
       BNE .Return                 ;/

       JSL $01ACF9                 ;\
       AND #$04                    ; | get the starting index for positions and store them
       STA !RAM_MiscTracking,x     ;/
       
       LDA #$25                    ;\  Rawr :3
       STA !RAM_Port1              ;/
       LDA #$04                    ;\  less open mouth
       STA !RAM_PoseControl,x      ;/
       LDA #$80
       STA !RAM_AttackBp,x
BowserFire_Return:
       RTS

BowserFire_Fire:
       LDA #$33                    ;\
       CLC                         ; | spawn fireball
       %SpawnSprite()              ; | unless there's no index available
       BCS BowserFire_Return       ;/
       TYA                         ;   literally die

       LDX !RAM_SpriteIndex        ;   temp index restore
       LDY !RAM_MiscTracking,x     ;\  x position
       TAX                         ; | restore new sprite index
       LDA FireXPos,y              ; |
       STA !RAM_SpriteXLo,x        ;/

       LDA #$90                    ;\  y pos = 90
       STA !RAM_SpriteYLo,x        ;/
       STZ !RAM_SpriteYHi,x        ;   y hi = 0

       INC !RAM_SpriteState,x      ;   we want bowser's fireball, not podoboo
       ASL !1686,x                 ;\  interact with objects = yes
       LSR !1686,x                 ;/
       LDA #$39                    ;\  new clipping
       STA !1662,x                 ;/
       STZ !RAM_SpriteSpeedX,x     ;\  i hate these shared routines
       STZ !RAM_SpriteSpeedY,x     ;/
       LDA #$08                    ;\  you have no idea how much I hate them
       STA !RAM_SpriteStatus,x     ;/

       LDA #$27                    ;\  play sfx
       STA !RAM_Port4              ;/
       LDX !RAM_SpriteIndex        ;   retrieve index

       LDA #$20                    ;\  time for next fireball
       STA !RAM_DecrTblA,x         ;/

       LDA !RAM_MiscTracking,x     ;\
       INC                         ; | increase fireball counter
       STA !RAM_MiscTracking,x     ;/
       LDA !RAM_AttackBp,x         ;\
       INC                         ; |
       STA !RAM_AttackBp,x         ; | return if 4 fireballs haven't been spawned yet
       CMP #$84                    ; |
       BCC BowserFire_Return       ;/
       STZ !RAM_AttackBp,x         ;   allow for another attacks
       LDY !RAM_SpriteHealth,x     ;\
       DEY                         ; | timer
       LDA AttckTimer,y            ; |
       STA !RAM_DecrTblA,x         ;/
       STZ !RAM_MiscTracking,x     ;   allow to be re-used
       LDA #$01                    ;\  reset pose
       STA !RAM_PoseControl,x      ;/
       RTS

FireXPos:
       db $40,$60,$80,$A0,$B0,$90,$70,$50

;========================
; Shake and Spawn Rocks
;========================

ShakeAndRocks:
       LDA !RAM_AttackBp,x         ;\
       ORA #$01                    ; |  avoid attack re-seeding
       STA !RAM_AttackBp,x         ;/

       LDA !RAM_DecrTblA,x
       BEQ .Shake

       BIT !RAM_AttackBp,x         ;\  don't jump more than once
       BMI +                       ; |
       DEC                         ; | check if time to jump
       BEQ .Jump                   ; |
       BIT !RAM_AttackBp,x         ; | don't roar more than once
+      BVS .ShortReturn            ; |
       CMP #$08                    ; | check if time to roar
       BCS .ShortReturn            ;/

       LDA #$04                    ;\  less open mouth
       STA !RAM_PoseControl,x      ;/
       LDA #$25                    ;\  Rawr :3
       STA !RAM_Port1              ;/
       LDA !RAM_AttackBp,x         ;\
       ORA #$40                    ; | indicate that action happened
       STA !RAM_AttackBp,x         ;/
.ShortReturn
       RTS

.Jump
       LDA #$B0                    ;\  might as wll jump (JUMP!)
       STA !RAM_SpriteSpeedY,x     ;/
       LDA #$01                    ;\  stand still
       STA !RAM_PoseControl,x      ;/
       LDA !RAM_AttackBp,x         ;\
       ORA #$80                    ; | indicate that action happened
       STA !RAM_AttackBp,x         ;/
       RTS

.Shake
       LDA !RAM_ObjStatus,x        ;\
       AND #$04                    ; | don't do anything in the jump phase
       BEQ .ShortReturn            ;/

       LDA #$11                    ;\  shake layer 1
       STA $1887|!Base2            ;/

       LDA !RAM_FrameCounterB      ;\
       BIT #$0F                    ; | don't spawn rocks every second like wtf
       BNE .Reset                  ;/
       AND #$01                    ;\  don't play sound every other frame
       BNE +                       ;/
       LDA #$09                    ;\  this kinda sounds like a earthquake so It Ok
       STA !RAM_Port4              ;/

+      LDA #$B2                    ;\
       CLC                         ; | spawn rock
       %SpawnSprite()              ; | unless there's no index available
       BCS .Return                 ;/

       TYX                         ;\  make the thing fall
       INC !RAM_SpriteState,x      ;/
       LDA #$E4                    ;\  more speed
       STA !RAM_SpriteSpeedY,x     ;/
       STA !RAM_SpriteSpeedX,x

       LDA #$D0                    ;\
       %RangedRNG()                ; |
       CLC                         ; | x pos = rand(0,D0)+10&F0
       ADC #$10                    ; |
       AND #$F0                    ; |
       STA !RAM_SpriteXLo,x        ;/

       LDA #$90                    ;\  y pos = 90
       STA !RAM_SpriteYLo,x        ;/
       STZ !RAM_SpriteYHi,x        ;   y hi = 0

       LDX !RAM_SpriteIndex

       LDA #$0A
       STA !RAM_DecrTblA,x
.Reset
       LDA !RAM_MiscTracking,x
       INC
       STA !RAM_MiscTracking,x
       CMP #$30
       BCC .Return
       STZ !RAM_AttackBp,x         ;   allow for another attacks
       LDY !RAM_SpriteHealth,x     ;\
       DEY                         ; | timer
       LDA AttckTimer,y            ; |
       STA !RAM_DecrTblA,x         ;/
       STZ !RAM_MiscTracking,x     ;   allow to be re-used
       LDA #$01
       STA !RAM_PoseControl,x      ;   reset pose
.Return
       RTS

AttckTimer:
       db $28,$35,$43,$50

;========================
; Charge against Mario
;========================

ChargeMario:
       LDA !RAM_AttackBp,x
       ORA #$01
       STA !RAM_AttackBp,x

       LDA !RAM_DecrTblA,x
       BNE .Return
       BIT !RAM_AttackBp,x
       BPL +
       JMP Respawn
+      BVC Despawn

;== Charge attack ==;

.Charge
       LDA !RAM_ObjStatus,x
       AND #$03
       BNE .SpawnBlock
       LDA !RAM_SpriteHealth,x
       DEC
       ASL
       CLC
       ADC !RAM_SpriteDir,x
       TAY
       LDA RunSpeed,y
       STA !RAM_SpriteSpeedX,x
       LDA !RAM_FrameCounterB
       AND #$07
       BNE .Return
       LDA #$01
       STA !RAM_Port1
.Return
       RTS

.SpawnBlock
       LDA !RAM_MiscTracking,x
       CMP #$03
       BCC +

       LDA #$09
       STA !RAM_Port4

       LDA #$EA
       STA !RAM_SpriteSpeedY,x
       LDY !RAM_SpriteDir,x
       LDA ReflectSpeed,y
       STA !RAM_SpriteSpeedX,x

       LDA !RAM_MiscTracking,x
       CMP #$04
       BNE +
       LDA #!BigBlockNum
       SEC
       %SpawnSprite()
       BCS .Return

       TYX
       LDA $94
       STA !RAM_SpriteXLo,x
       STA !RAM_SpriteSpeedX,x
       STA !RAM_SpriteSpeedY,x

       LDA #$90                    ;\  y pos = 90
       STA !RAM_SpriteYLo,x        ;/
       STZ !RAM_SpriteYHi,x        ;   y hi = 0
       LDX !RAM_SpriteIndex
+      INC !RAM_MiscTracking,x
       LDA !RAM_MiscTracking,x
       CMP #$05
       BCC +
       LDY !RAM_SpriteHealth,x
       DEY
       LDA VulnTimes,y
       STA !RAM_VulnTimer,x
       INC !FreeRAM
       STZ !RAM_AttackBp,x
       STZ !RAM_MiscTracking,x
+      RTS

;== Disappear ==;

Despawn:
       LDA !RAM_AttackBp,x
       AND #$04
       BNE .SkipThis

       %SpinjumpStars()

       LDA #$04
       STA !RAM_AttackBp,x
       LDA #$1F
       STA !RAM_DecrTblB,x
       LDA #$80
       STA !RAM_PoseControl,x
       RTS

.SkipThis
       LDA !RAM_DecrTblB,x
       BEQ .End
       %GetDrawInfo()
       REP #$20
       LDA $00
       SEC
       SBC #$0404
       STA $0200|!Base2
       SEP #$20
       LDA !RAM_DecrTblB,x
       LSR #3
       AND #$03
       TAX
       LDA.l $019A4E,x
       STA $0202|!Base2
       LDX !RAM_SpriteIndex
       LDA #$30
       STA $0203|!Base2
       LDA #$02
       STA $0420|!Base2
       RTS

.End
       LDA #$F0
       STA $0201|!Base2
       LDY !RAM_SpriteHealth,x
       DEY
       LDA ReappearTimes,y
       STA !RAM_DecrTblA,x
       LDA #$80
       STA !RAM_AttackBp,x
       RTS

;== Reappear ==;

Respawn:
       LDA !RAM_AttackBp,x
       AND #$04
       BNE SkipThisX

       LDA $94
       LSR #4
       TAY
       LDA PossibleXPos,y
       STA !RAM_SpriteXLo,x
       LDA #$50
       STA !RAM_SpriteYLo,x
       LDA #$01
       STA !RAM_SpriteYHi,x
       %SubHorzPos()
       TYA
       STA !RAM_SpriteDir,x

       %SpinjumpStars()

       LDA #$84
       STA !RAM_AttackBp,x
       LDA #$1F
       STA !RAM_DecrTblB,x
       STZ !RAM_PoseControl,x
       RTS

SkipThisX:
       LDA !RAM_DecrTblB,x
       BEQ EndX
       %GetDrawInfo()
       REP #$20
       LDA $00
       SEC
       SBC #$0404
       STA $0200|!Base2
       SEP #$20
       LDA !RAM_DecrTblB,x
       LSR #3
       AND #$03
       TAX
       LDA.l $019A4E,x
       STA $0202|!Base2
       LDX !RAM_SpriteIndex
       LDA #$30
       STA $0203|!Base2
       LDA #$02
       STA $0420|!Base2
       RTS

EndX:
       LDA #$F0
       STA $0201|!Base2
       LDA #$08
       STA !RAM_DecrTblA,x
       LDA #$40
       STA !RAM_AttackBp,x
       RTS

RunSpeed:
       db $24,$DC,$20,$E0,$1B,$E5,$18,$E8
ReflectSpeed:
       db $EC,$14
PossibleXPos:
       db $D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0
       db $40,$40,$40,$40,$40,$40,$40,$40
VulnTimes:
       db $10,$15,$27,$32
ReappearTimes:
       db $10,$1B,$25,$30

;==================
; Interaction
;==================

Interaction_ReturnMain:
       RTS
Interaction:
       LDA !RAM_FrameCounterB
       LSR
       BCS .ReturnMain
       LDA $71
       BNE .ReturnMain

       LDA $94
       SEC
       SBC !RAM_SpriteXLo,x
       CLC
       ADC #$50
       CMP #$A0
       BCS .ReturnMain
       LDA $96
       SEC
       SBC !RAM_SpriteYLo,x
       STA $0E
       CLC
       ADC #$60
       CMP #$C0
       BCS .ReturnMain

       JSL $03B664
       LDA !RAM_SpriteXLo,x
       SEC
       SBC #$06
       STA $04
       LDA !RAM_SpriteXHi,x
       SBC #$00
       STA $0A
       LDA !RAM_SpriteYLo,x
       SEC
       SBC #$06
       STA $05
       LDA !RAM_SpriteYHi,x
       SBC #$00
       STA $0B
       LDA #$1A
       STA $06
       LDA #$1E
       STA $07
       JSL $03B72B
       BCC .Return

       LDA $0E
       CMP #$EC
       BPL .HurtMario
       LDA $7D
       BMI .HurtMario
       LDA !RAM_VulnTimer,x
       BEQ .MaybeHurtMario

       JSL $01AA33
       JSL $01AB99
       LDA #$28
       STA !RAM_Port4
       LDA #$40
       STA !RAM_SpriteState,x
       STA !RAM_DecrTblA,x
       STZ !RAM_AttackBp,x
       STZ !RAM_VulnTimer,x
       DEC !RAM_SpriteHealth,x
       LDA !RAM_SpriteHealth,x
       BNE .Return
       LDA #$D0
       STA !RAM_DecrTblA,x
.Return
       RTS

.MaybeHurtMario
       LDA $140D|!Base2
       BNE .Spinjump
.HurtMario
       JSL $00F5B7
       RTS

.Spinjump
       JSL $01AA33
       JSL $01AB99
       LDA #$02
       STA !RAM_Port1
       RTS

;==================
; Graphics routine
;==================

Tilemap:
       db $80,$82,$8A,$AA
       db $80,$82,$A0,$A2
       db $84,$86,$A4,$A6
       db $88,$A8,$88,$A8
       db $C0,$C2,$E2,$A6

       db $80,$82,$8A,$AA
       db $80,$82,$A0,$A2
       db $84,$86,$A4,$A6
       db $88,$A8,$88,$A8
       db $C0,$C2,$E2,$A6

Properties:
       db $30,$30,$30,$30
       db $30,$30,$30,$30
       db $30,$30,$30,$30
       db $30,$30,$70,$70
       db $30,$30,$30,$30

       db $70,$70,$70,$70
       db $70,$70,$70,$70
       db $70,$70,$70,$70
       db $70,$70,$30,$30
       db $70,$70,$70,$70

XDisp:
       db $F0,$00,$F0,$00
       db $F0,$00,$F0,$00
       db $F0,$00,$F0,$00
       db $F0,$F0,$00,$00
       db $F0,$00,$F0,$00

       db $00,$F0,$00,$F0
       db $00,$F0,$00,$F0
       db $00,$F0,$00,$F0
       db $00,$00,$F0,$F0
       db $00,$F0,$00,$F0
YDisp:
       db $F0,$F0,$00,$00
       db $F0,$F0,$00,$00
       db $F0,$F0,$00,$00
       db $F0,$00,$F0,$00
       db $F0,$F0,$00,$00

       db $F0,$F0,$00,$00
       db $F0,$F0,$00,$00
       db $F0,$F0,$00,$00
       db $F0,$00,$F0,$00
       db $F0,$F0,$00,$00

Graphics:
       LDA !RAM_PoseControl,x
       BMI .Return
       %GetDrawInfo()

       LDA !RAM_PoseControl,x
       BEQ .WalkAnim

       ASL #2
       STA $03
       BRA .SetDir

.WalkAnim
       LDA !RAM_FrameCounterB
       LSR #4
       AND #$01
       ASL #2
       STA $03

.SetDir
       LDA !RAM_SpriteDir,x
       BNE +
       LDA $03
       CLC
       ADC #$14
       STA $03

+      LDA !15F6,x
       ORA $64
       STA $05

       LDX #$03
-      PHX

       TXA
       CLC
       ADC $03
       TAX

       LDA Tilemap,x
       STA $0302|!Base2,y

       LDA Properties,x
       ORA $05
       STA $0303|!Base2,y

       LDA $00
       CLC
       ADC XDisp,x
       STA $0300|!Base2,y

       LDA $01
       CLC
       ADC YDisp,x
       STA $0301|!Base2,y

       PLX
       INY #4
       DEX
       BPL -

       LDX !RAM_SpriteIndex
       LDY #$02
       LDA #$03
       JSL $01B7B3
.Return
       RTS


;===================================================
; Patches required for this to work
; May break the original Ludwig, Reznor and Bowser
;===================================================

pushpc
       ;=============================
       ; Improved Ludwig's Fireball
       ; By Erik557 for 24HoSMW
       ;=============================

       org $018634
              dw LudwigFireMain
       org $0181E5
              dw LudwigFireInit

       org $01D442
       LudwigFireMain:
              LDA $9D
              BNE label_01D455
              JSR $8E5F
              JSR $8E5F
              JSR $A7E4
              JSR $ABCC
              JSR $ABD8
              JSR $AC31
       label_01D455:
              JSR $A365
              LDA !RAM_PoseControl,x
              ASL
              STA $03
              LDA !RAM_SpriteDir,x
              ASL
              STA $02

              LDX #$01
       label_01D466:
              PHX
              PHX
              TXA
              CLC
              ADC $02
              TAX
              LDA $00
              CLC
              ADC xdisp,x
              STA $0300,y
              LDA $01
              INC #2
              STA $0301,y
              LDA props,x
              STA $0303,y
              PLA
              CLC
              ADC $03
              TAX
              LDA tilemap,x
              STA $0302,y
              PLX
              INY #4
              DEX
              BPL label_01D466
              LDX !RAM_SpriteIndex
              LDY #$02
              LDA #$01
              JMP $B7BB

       LudwigFireInit:
              JSR $AD30
              TYA
              STA !RAM_SpriteDir,x
              LDA xspeeds,y
              STA !RAM_SpriteSpeedX,x
              LDA #$17
              STA !RAM_Port4
              RTS

       xspeeds:
              db $20,$E0
       xdisp:
              db $00,$F0,$00,$10
       tilemap:
              db $4A,$4C,$6A,$6C
       props:
              db $75,$75,$35,$35

       ;=========================================
       ; - Remaps Reznor's fireball
       ; - Remaps the fire from Bowser's stage
       ; - Fixes's the fire from Bowser's stage
       ;=========================================

       org $01E151
              BRA +
       org $01E16D
       +
       org $02A163
              db $8C,$AC,$8C,$AC
       org $01E190
              db $2A,$2C,$2A,$2C
pullpc

